#include <initializer_list>
#include <iostream>
#include <string>
#include <vector>

template <typename T>
class sequence{

  public:
    sequence()= default;

    sequence(std::initializer_list<T> inList):data(inList){}

    void appendElements(std::initializer_list<T> inList){
      data.insert(data.end(),inList);
    }

    void showMe() const {
      for (auto e: data) std::cout << e << " ";
      std::cout << std::endl;
    }

  private:
    std::vector<T> data;
};

int main(){

  std::cout << std::endl;

  sequence<char> seqChars={'a','b','c','d','e','f','g'};
  sequence<int> seqInts= {1,2,3,4,5};
  sequence<double> seqDoubles={};
  sequence<std::string> seqStrings;

  seqChars.appendElements({'h','i','j'});
  seqInts.appendElements({4,3,2,1});
  seqDoubles.appendElements({1.1,2.2,3.3});
  seqStrings.appendElements({"one","two","three"});

  seqChars.showMe();
  seqInts.showMe();
  seqDoubles.showMe();
  seqStrings.showMe();

  std::cout << std::endl;

}
